# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class Kpi(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, min: float=None, avg: float=None, max: float=None):  # noqa: E501
        """Kpi - a model defined in Swagger

        :param min: The min of this Kpi.  # noqa: E501
        :type min: float
        :param avg: The avg of this Kpi.  # noqa: E501
        :type avg: float
        :param max: The max of this Kpi.  # noqa: E501
        :type max: float
        """
        self.swagger_types = {
            'min': float,
            'avg': float,
            'max': float
        }

        self.attribute_map = {
            'min': 'min',
            'avg': 'avg',
            'max': 'max'
        }
        self._min = min
        self._avg = avg
        self._max = max

    @classmethod
    def from_dict(cls, dikt) -> 'Kpi':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Kpi of this Kpi.  # noqa: E501
        :rtype: Kpi
        """
        return util.deserialize_model(dikt, cls)

    @property
    def min(self) -> float:
        """Gets the min of this Kpi.


        :return: The min of this Kpi.
        :rtype: float
        """
        return self._min

    @min.setter
    def min(self, min: float):
        """Sets the min of this Kpi.


        :param min: The min of this Kpi.
        :type min: float
        """
        if min is None:
            raise ValueError("Invalid value for `min`, must not be `None`")  # noqa: E501

        self._min = min

    @property
    def avg(self) -> float:
        """Gets the avg of this Kpi.


        :return: The avg of this Kpi.
        :rtype: float
        """
        return self._avg

    @avg.setter
    def avg(self, avg: float):
        """Sets the avg of this Kpi.


        :param avg: The avg of this Kpi.
        :type avg: float
        """
        if avg is None:
            raise ValueError("Invalid value for `avg`, must not be `None`")  # noqa: E501

        self._avg = avg

    @property
    def max(self) -> float:
        """Gets the max of this Kpi.


        :return: The max of this Kpi.
        :rtype: float
        """
        return self._max

    @max.setter
    def max(self, max: float):
        """Sets the max of this Kpi.


        :param max: The max of this Kpi.
        :type max: float
        """
        if max is None:
            raise ValueError("Invalid value for `max`, must not be `None`")  # noqa: E501

        self._max = max
